Index: /trunk/lib/FlairMeta/src/UavFactory.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/UavFactory.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/UavFactory.cpp	(revision 122)
@@ -30,5 +30,5 @@
 
 namespace { // anonymous
-     vector<flair::meta::Uav* (*)(FrameworkManager*,string,string,UavMultiplex*)> *vectoroffunctions=NULL;
+     vector<flair::meta::Uav* (*)(string,string,UavMultiplex*)> *vectoroffunctions=NULL;
 }
 
@@ -41,5 +41,5 @@
 
 
-Uav *CreateUav(FrameworkManager *parent, string uav_name, string uav_type,
+Uav *CreateUav(string name, string uav_type,
                UavMultiplex *multiplex) {
 
@@ -48,5 +48,5 @@
   if(vectoroffunctions!=NULL) {
     for(int i=0;i<vectoroffunctions->size();i++) {
-      uav=vectoroffunctions->at(i)(parent, uav_name, uav_type,multiplex);
+      uav=vectoroffunctions->at(i)(name,uav_type,multiplex);
       if(uav!=NULL) {
         free(vectoroffunctions);
@@ -58,12 +58,12 @@
 
   if (uav_type == "hds_x4") {
-    parent->Err("UAV type %s not yet implemented\n", uav_type.c_str());
+    getFrameworkManager()->Err("UAV type %s not yet implemented\n", uav_type.c_str());
     return NULL;
   } else if (uav_type == "hds_x8") {
-    return new HdsX8(parent, uav_name, multiplex);
+    return new HdsX8(name, multiplex);
   } else if (uav_type == "xair") {
-    return new XAir(parent, uav_name, multiplex);
+    return new XAir(name, multiplex);
   } else if (uav_type == "hds_xufo") {
-    parent->Err("UAV type %s not yet implemented\n", uav_type.c_str());
+    getFrameworkManager()->Err("UAV type %s not yet implemented\n", uav_type.c_str());
     return NULL;
   } else if (uav_type.compare(0, 7, "x4_simu") == 0) {
@@ -72,5 +72,5 @@
       simu_id = atoi(uav_type.substr(7, uav_type.size() - 7).c_str());
     }
-    return new SimuX4(parent, uav_name, simu_id, multiplex);
+    return new SimuX4(name, simu_id, multiplex);
   } else if (uav_type.compare(0, 7, "x8_simu") == 0) {
     int simu_id = 0;
@@ -78,14 +78,14 @@
       simu_id = atoi(uav_type.substr(7, uav_type.size() - 7).c_str());
     }
-    return new SimuX8(parent, uav_name, simu_id, multiplex);
+    return new SimuX8(name, simu_id, multiplex);
   } else {
-    parent->Err("UAV type %s unknown\n", uav_type.c_str());
+    getFrameworkManager()->Err("UAV type %s unknown\n", uav_type.c_str());
     return NULL;
   }
 }
 
-void RegisterUavCreator(flair::meta::Uav*(*func)(FrameworkManager *parent, string uav_name, string uav_type,
+void RegisterUavCreator(flair::meta::Uav*(*func)(string name, string type,
                UavMultiplex *multiplex)) {
-  if(vectoroffunctions==NULL) vectoroffunctions=(vector<flair::meta::Uav* (*)(FrameworkManager*,string,string,UavMultiplex*)>*)malloc(sizeof(vector<flair::meta::Uav* (*)(FrameworkManager*,string,string,UavMultiplex*)>));
+  if(vectoroffunctions==NULL) vectoroffunctions=(vector<flair::meta::Uav* (*)(string,string,UavMultiplex*)>*)malloc(sizeof(vector<flair::meta::Uav* (*)(string,string,UavMultiplex*)>));
 
   vectoroffunctions->push_back(func);
Index: /trunk/lib/FlairMeta/src/UavFactory.h
===================================================================
--- /trunk/lib/FlairMeta/src/UavFactory.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/UavFactory.h	(revision 122)
@@ -21,10 +21,8 @@
 #include <Uav.h>
 
-flair::meta::Uav *CreateUav(flair::core::FrameworkManager *parent,
-                            std::string uav_name, std::string uav_type,
+flair::meta::Uav *CreateUav(std::string name, std::string type,
                             flair::filter::UavMultiplex *multiplex = NULL);
 
-void RegisterUavCreator(flair::meta::Uav*(*func)(flair::core::FrameworkManager *parent,
-                                   std::string uav_name, std::string uav_type,
+void RegisterUavCreator(flair::meta::Uav*(*func)(std::string name, std::string type,
                                    flair::filter::UavMultiplex *multiplex));
 #endif // UAVFACTORY
Index: /trunk/lib/FlairMeta/src/UavStateMachine.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/UavStateMachine.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/UavStateMachine.cpp	(revision 122)
@@ -52,7 +52,7 @@
 using namespace flair::meta;
 
-UavStateMachine::UavStateMachine(Uav* inUav,TargetController *controller):
+UavStateMachine::UavStateMachine(TargetController *controller):
         Thread(getFrameworkManager(),"UavStateMachine",50),
-        uav(inUav),controller(controller),failSafeMode(true),flagConnectionLost(false),flagBatteryLow(false),flagCriticalSensorLost(false),flagZTrajectoryFinished(false),safeToFly(true){
+        uav(GetUav()),controller(controller),failSafeMode(true),flagConnectionLost(false),flagBatteryLow(false),flagCriticalSensorLost(false),flagZTrajectoryFinished(false),safeToFly(true){
     altitudeState=AltitudeState_t::Stopped;
     uav->UseDefaultPlot();
@@ -135,6 +135,4 @@
   return currentAngularSpeed;
 }
-
-const Uav *UavStateMachine::GetUav(void) const { return uav; }
 
 void UavStateMachine::AltitudeValues(float &altitude,
Index: /trunk/lib/FlairMeta/src/UavStateMachine.h
===================================================================
--- /trunk/lib/FlairMeta/src/UavStateMachine.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/UavStateMachine.h	(revision 122)
@@ -59,7 +59,8 @@
 *
 * \brief State machine for UAV
-*
-* thread synchronized with ahrs, unless a period is set with SetPeriodUS or
-*SetPeriodMS
+*  The Thread is created with 
+*  the FrameworkManager as parent. FrameworkManager must be created before.
+* The Thread is synchronized with Ahrs, unless a period is set with SetPeriodUS or
+* SetPeriodMS
 */
 
@@ -101,5 +102,5 @@
   };
 
-        UavStateMachine(meta::Uav* uav, sensor::TargetController* controller);
+        UavStateMachine(sensor::TargetController* controller);
         ~UavStateMachine();
 
@@ -107,6 +108,4 @@
 
   const core::Vector3D &GetCurrentAngularSpeed(void) const;
-
-  const meta::Uav *GetUav(void) const;
 
         void Land(void);
Index: /trunk/lib/FlairMeta/src/XAir.cpp
===================================================================
--- /trunk/lib/FlairMeta/src/XAir.cpp	(revision 121)
+++ /trunk/lib/FlairMeta/src/XAir.cpp	(revision 122)
@@ -38,34 +38,22 @@
 namespace meta {
 
-XAir::XAir(FrameworkManager *parent, string uav_name,
+XAir::XAir(string name,
            filter::UavMultiplex *multiplex)
-    : Uav(parent, uav_name, multiplex) {
-  RTDM_I2cPort *i2cport = new RTDM_I2cPort(parent, "rtdm_i2c", "rti2c3");
-  RTDM_SerialPort *imu_port = new RTDM_SerialPort(parent, "imu_port", "rtser1");
+    : Uav(name, multiplex) {
+  RTDM_I2cPort *i2cport = new RTDM_I2cPort(getFrameworkManager(), "rtdm_i2c", "rti2c3");
+  RTDM_SerialPort *imu_port = new RTDM_SerialPort(getFrameworkManager(), "imu_port", "rtser1");
 
   if (multiplex == NULL)
-    SetMultiplex(new X4X8Multiplex(parent, "motors", X4X8Multiplex::X8));
+    SetMultiplex(new X4X8Multiplex(getFrameworkManager(), "motors", X4X8Multiplex::X8));
 
   SetBldc(new AfroBldc(GetUavMultiplex(), GetUavMultiplex()->GetLayout(),
                        "motors", GetUavMultiplex()->MotorsCount(), i2cport));
-  SetUsRangeFinder(new Srf08(parent, "SRF08", i2cport, 0x70, 60));
-  SetAhrs(new Gx3_25_ahrs(parent, "imu", imu_port,
+  SetUsRangeFinder(new Srf08(getFrameworkManager(), "SRF08", i2cport, 0x70, 60));
+  SetAhrs(new Gx3_25_ahrs(getFrameworkManager(), "imu", imu_port,
                           Gx3_25_imu::AccelerationAngularRateAndOrientationMatrix, 70));
-  Tab *bat_tab = new Tab(parent->GetTabWidget(), "battery");
+  Tab *bat_tab = new Tab(getFrameworkManager()->GetTabWidget(), "battery");
   SetBatteryMonitor(new BatteryMonitor(bat_tab->NewRow(), "battery"));
   GetBatteryMonitor()->SetBatteryValue(12);
-
-  /*
-          if(VRPNType==Auto || VRPNType==AutoSerialPort)
-          {
-              RTDM_SerialPort* vrpn_port=new
-     RTDM_SerialPort(parent,"vrpn_port","rtser3");
-
-              vrpnclient=new VrpnClient(parent,"vrpn",vrpn_port,10000,80);
-              uav_vrpn=new
-     MetaVrpnObject(vrpnclient,uav_name,VRPNSerialObjectId);
-          }
-  */
-  SetVerticalCamera(new Ps3Eye(parent, "camv", 0, 50));
+  SetVerticalCamera(new Ps3Eye(getFrameworkManager(), "camv", 0, 50));
 }
 
@@ -76,5 +64,4 @@
   ((Srf08 *)GetUsRangeFinder())->Start();
   ((Ps3Eye *)GetVerticalCamera())->Start();
-  Uav::StartSensors();
 }
 
Index: /trunk/lib/FlairMeta/src/XAir.h
===================================================================
--- /trunk/lib/FlairMeta/src/XAir.h	(revision 121)
+++ /trunk/lib/FlairMeta/src/XAir.h	(revision 122)
@@ -24,8 +24,9 @@
 class XAir : public Uav {
 public:
-  XAir(core::FrameworkManager *parent, std::string uav_name,
+  XAir(std::string name,
        filter::UavMultiplex *multiplex = NULL);
   ~XAir();
   void StartSensors(void);
+	std::string GetDefaultVrpnAddress(void) const{return "192.168.147.197:3883";}
 
 private:
Index: /trunk/lib/FlairSensorActuator/src/Camera.cpp
===================================================================
--- /trunk/lib/FlairSensorActuator/src/Camera.cpp	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/Camera.cpp	(revision 122)
@@ -24,5 +24,4 @@
 #include <DataPlot1D.h>
 #include <Picture.h>
-#include <Buffer.h>
 #include <highgui.h>
 #include <fstream>
@@ -39,5 +38,4 @@
     : IODevice(parent, name) {
   plot_tab = NULL;
-	jpgBuffer=NULL;
 	logFormat=LogFormat::NONE;
 
@@ -63,5 +61,4 @@
 
   output = NULL;
-	jpgBuffer=NULL;
 	logFormat=LogFormat::NONE;
 }
@@ -80,11 +77,9 @@
 			break;
 		case LogFormat::JPG:
-			if(jpgBuffer==NULL) {
-				jpgBuffer=new Buffer(this,"jpg_bufer");
-				AddDataToLog(jpgBuffer);
-			}else{
-				Warn("log format already defined\n");
-			}
+				Warn("logging cvimage to jpeg\n");
+				Warn("jpeg are not included in classical dbt file, as dbt does not handle variable length\n");
 			break;
+		default:
+			Warn("LogFormat unknown\n");
 	}
 }
@@ -119,8 +114,11 @@
 
 void Camera::ProcessUpdate(core::io_data* data) {
-	switch(logFormat) {
-		case LogFormat::JPG:
-				ajouter compression jpg
-			break;
+	if(getFrameworkManager()->IsLogging() && getFrameworkManager()->IsDeviceLogged(this)) {
+		switch(logFormat) {
+			case LogFormat::JPG:
+					IplImage *img=((cvimage*)data)->img;
+					//dspSaveToJpeg(img,"toto");
+				break;
+		}
 	}
 	IODevice::ProcessUpdate(data);
Index: /trunk/lib/FlairSensorActuator/src/Camera.h
===================================================================
--- /trunk/lib/FlairSensorActuator/src/Camera.h	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/Camera.h	(revision 122)
@@ -25,7 +25,4 @@
 		class Picture;
 		class GridLayout;
-	}
-	namespace core {
-		class Buffer;
 	}
 }
@@ -163,5 +160,4 @@
   gui::GridLayout *setup_layout;
 	LogFormat logFormat;
-	core::Buffer *jpgBuffer;
 };
 } // end namespace sensor
Index: /trunk/lib/FlairSensorActuator/src/VrpnClient.cpp
===================================================================
--- /trunk/lib/FlairSensorActuator/src/VrpnClient.cpp	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/VrpnClient.cpp	(revision 122)
@@ -26,17 +26,36 @@
 using namespace flair::gui;
 
+namespace {
+  flair::sensor::VrpnClient *singleton = NULL;
+}
+
+
 namespace flair {
 namespace sensor {
 
-VrpnClient::VrpnClient(const FrameworkManager *parent, string name,
+VrpnClient *GetVrpnClient(void) { return singleton; }
+	
+VrpnClient::VrpnClient(string name,
                        string address, uint16_t us_period, uint8_t priority)
-    : Thread(parent, name, priority) {
+    : Thread(getFrameworkManager(), name, priority) {
+	if (singleton != NULL) {
+    Err("VrpnClient must be instanced only one time\n");
+    return;
+  }
+
+  singleton = this;
   pimpl_ = new VrpnClient_impl(this, name, address, us_period);
 }
 
-VrpnClient::VrpnClient(const FrameworkManager *parent, string name,
+VrpnClient::VrpnClient(string name,
                        SerialPort *serialport, uint16_t us_period,
                        uint8_t priority)
-    : Thread(parent, name, priority) {
+    : Thread(getFrameworkManager(), name, priority) {
+	if (singleton != NULL) {
+    Err("VrpnClient must be instanced only one time\n");
+    return;
+  }
+
+  singleton = this;
   pimpl_ = new VrpnClient_impl(this, name, serialport, us_period);
 }
Index: /trunk/lib/FlairSensorActuator/src/VrpnClient.h
===================================================================
--- /trunk/lib/FlairSensorActuator/src/VrpnClient.h	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/VrpnClient.h	(revision 122)
@@ -18,12 +18,11 @@
 
 namespace flair {
-namespace core {
-class FrameworkManager;
-class SerialPort;
-}
-namespace gui {
-class TabWidget;
-class Layout;
-}
+	namespace core {
+		class SerialPort;
+	}
+	namespace gui {
+		class TabWidget;
+		class Layout;
+	}
 }
 
@@ -35,5 +34,7 @@
 /*! \class VrpnClient
 *
-* \brief Class to connect to a Vrpn server
+* \brief Class to connect to a Vrpn server. The Thread is created with 
+*  the FrameworkManager as parent. FrameworkManager must be created before.
+* Only one instance of this class is allowed by program.
 */
 class VrpnClient : public core::Thread {
@@ -46,5 +47,4 @@
   * Construct a VrpnClient. Connection is done by IP.
   *
-  * \param parent parent
   * \param name name
   * \param address server address
@@ -52,5 +52,5 @@
   * \param priority priority of the Thread
   */
-  VrpnClient(const core::FrameworkManager *parent, std::string name,
+  VrpnClient(std::string name,
              std::string address, uint16_t us_period, uint8_t priority);
 
@@ -60,5 +60,4 @@
   * Construct a VrpnClient. Connection is done by XBee modem.
   *
-  * \param parent parent
   * \param name name
   * \param serialport SerialPort for XBee modem
@@ -66,5 +65,5 @@
   * \param priority priority of the Thread
   */
-  VrpnClient(const core::FrameworkManager *parent, std::string name,
+  VrpnClient(std::string name,
              core::SerialPort *serialport, uint16_t us_period,
              uint8_t priority);
@@ -108,4 +107,12 @@
   class VrpnClient_impl *pimpl_;
 };
+
+/*!
+* \brief get VrpnClient
+*
+* \return the VrpnClient
+*/
+VrpnClient *GetVrpnClient(void);
+
 } // end namespace sensor
 } // end namespace flair
Index: /trunk/lib/FlairSensorActuator/src/VrpnObject.cpp
===================================================================
--- /trunk/lib/FlairSensorActuator/src/VrpnObject.cpp	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/VrpnObject.cpp	(revision 122)
@@ -30,16 +30,16 @@
 namespace sensor {
 
-VrpnObject::VrpnObject(const VrpnClient *parent, string name,
+VrpnObject::VrpnObject(string name,
                        const TabWidget *tab)
-    : IODevice(parent, name) {
-  pimpl_ = new VrpnObject_impl(this, parent, name, -1, tab);
+    : IODevice(GetVrpnClient(), name) {
+  pimpl_ = new VrpnObject_impl(this, name, -1, tab);
   AddDataToLog(pimpl_->output);
 }
 
-VrpnObject::VrpnObject(const VrpnClient *parent, string name, uint8_t id,
+VrpnObject::VrpnObject(string name, uint8_t id,
                        const TabWidget *tab)
-    : IODevice(parent, name) {
+    : IODevice(GetVrpnClient(), name) {
   Warn("Creation of object %s with id %i\n", name.c_str(), id);
-  pimpl_ = new VrpnObject_impl(this, parent, name, id, tab);
+  pimpl_ = new VrpnObject_impl(this, name, id, tab);
   AddDataToLog(pimpl_->output);
 }
Index: /trunk/lib/FlairSensorActuator/src/VrpnObject.h
===================================================================
--- /trunk/lib/FlairSensorActuator/src/VrpnObject.h	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/VrpnObject.h	(revision 122)
@@ -19,15 +19,15 @@
 
 namespace flair {
-namespace core {
-class cvmatrix;
-class Vector3D;
-class Euler;
-class Quaternion;
-}
-namespace gui {
-class TabWidget;
-class Tab;
-class DataPlot1D;
-}
+	namespace core {
+		class cvmatrix;
+		class Vector3D;
+		class Euler;
+		class Quaternion;
+	}
+	namespace gui {
+		class TabWidget;
+		class Tab;
+		class DataPlot1D;
+	}
 }
 
@@ -41,5 +41,6 @@
 /*! \class VrpnObject
 *
-* \brief Class for VRPN object
+* \brief Class for VRPN object. The IODevice is created with 
+*  the VrpnClient as parent. VrpnClient must be created before.
 */
 class VrpnObject : public core::IODevice {
@@ -53,9 +54,8 @@
   * Construct a VrpnObject. Connection is done by IP.
   *
-  * \param parent parent
   * \param name VRPN object name, should be the same as defined in the server
   * \param tab Tab for the user interface
   */
-  VrpnObject(const VrpnClient *parent, std::string name,
+  VrpnObject(std::string name,
              const gui::TabWidget *tab);
 
@@ -65,10 +65,9 @@
   * Construct a VrpnObject. Connection is done by IP.
   *
-  * \param parent parent
   * \param name name
   * \param id VRPN object id, should be the same as defined in the server
   * \param tab Tab for the user interface
   */
-  VrpnObject(const VrpnClient *parent, std::string name, uint8_t id,
+  VrpnObject(std::string name, uint8_t id,
              const gui::TabWidget *tab);
 
Index: /trunk/lib/FlairSensorActuator/src/VrpnObject_impl.cpp
===================================================================
--- /trunk/lib/FlairSensorActuator/src/VrpnObject_impl.cpp	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/VrpnObject_impl.cpp	(revision 122)
@@ -39,9 +39,13 @@
 using namespace flair::sensor;
 
-VrpnObject_impl::VrpnObject_impl(VrpnObject *self, const VrpnClient *parent,
+VrpnObject_impl::VrpnObject_impl(VrpnObject *self,
                                  string name, int id, const TabWidget *tab) {
-  this->parent = parent;
+  parent = GetVrpnClient();
   this->self = self;
 
+	if(parent==NULL) {
+		self->Err("VrpnClient must be instanced before creating VrpnObject\n");
+		return;
+	}
   if (id == -1 && parent->UseXbee()) {
     self->Err("erreur aucun identifiant specifie pour la connexion Xbee\n");
Index: /trunk/lib/FlairSensorActuator/src/unexported/VrpnObject_impl.h
===================================================================
--- /trunk/lib/FlairSensorActuator/src/unexported/VrpnObject_impl.h	(revision 121)
+++ /trunk/lib/FlairSensorActuator/src/unexported/VrpnObject_impl.h	(revision 122)
@@ -26,18 +26,18 @@
 
 namespace flair {
-namespace core {
-class cvmatrix;
-class Vector3D;
-class Euler;
-}
-namespace gui {
-class TabWidget;
-class Tab;
-class DataPlot1D;
-}
-namespace sensor {
-class VrpnClient;
-class VrpnObject;
-}
+	namespace core {
+		class cvmatrix;
+		class Vector3D;
+		class Euler;
+	}
+	namespace gui {
+		class TabWidget;
+		class Tab;
+		class DataPlot1D;
+	}
+	namespace sensor {
+		class VrpnClient;
+		class VrpnObject;
+	}
 }
 
@@ -47,5 +47,5 @@
 public:
   VrpnObject_impl(flair::sensor::VrpnObject *self,
-                  const flair::sensor::VrpnClient *parent, std::string name,
+                  std::string name,
                   int id, const flair::gui::TabWidget *tab);
   ~VrpnObject_impl(void);
Index: /trunk/lib/FlairVisionFilter/CMakeLists.txt
===================================================================
--- /trunk/lib/FlairVisionFilter/CMakeLists.txt	(revision 122)
+++ /trunk/lib/FlairVisionFilter/CMakeLists.txt	(revision 122)
@@ -0,0 +1,48 @@
+PROJECT(FlairVisionFilter)
+cmake_minimum_required(VERSION 2.8)
+include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
+
+find_package(LibXml2 REQUIRED)
+
+execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
+                OUTPUT_VARIABLE GCC_VERSION)
+
+if (GCC_VERSION VERSION_GREATER 4.3 OR GCC_VERSION VERSION_EQUAL 4.3)
+	if (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
+		ADD_DEFINITIONS("-std=c++11")
+	else()
+		ADD_DEFINITIONS("-std=c++0x")
+	endif()
+else()
+	message(STATUS "GCC version < 4.3, c+11 is not supported!")
+endif()
+
+INCLUDE_DIRECTORIES(
+	${LIBXML2_INCLUDE_DIR}
+	${CMAKE_CURRENT_SOURCE_DIR}/src
+	$ENV{FLAIR_ROOT}/flair-src/lib/FlairCore/src
+	${CMAKE_SYSROOT}/usr/include/opencv
+)
+
+FILE(GLOB SRC_SRC "${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp")
+
+SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
+
+ADD_LIBRARY(${PROJECT_NAME}
+	${SRC_SRC}
+)
+
+INSTALL(TARGETS ${PROJECT_NAME}
+	LIBRARY DESTINATION $ENV{FLAIR_ROOT}/flair-bin/lib/${ARCH_DIR}
+	ARCHIVE DESTINATION $ENV{FLAIR_ROOT}/flair-bin/lib/${ARCH_DIR}
+)
+
+FILE(GLOB HEADER_FILES "${CMAKE_CURRENT_SOURCE_DIR}/src/*.h")
+INSTALL(FILES ${HEADER_FILES} DESTINATION $ENV{FLAIR_ROOT}/flair-dev/include/${PROJECT_NAME})
+
+add_custom_target(
+	compile_info
+	COMMAND $ENV{FLAIR_ROOT}/flair-dev/scripts/compile_info.sh ${CMAKE_C_COMPILER} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src/unexported/compile_info.h
+)
+
+add_dependencies(${PROJECT_NAME} compile_info)
Index: /trunk/lib/FlairVisionFilter/src/CvtColor.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/CvtColor.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/CvtColor.cpp	(revision 122)
@@ -0,0 +1,90 @@
+//  created:    2014/07/17
+//  filename:   CvtColor.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Image color conversion
+//
+//
+/*********************************************************************/
+
+#include "CvtColor.h"
+#include <cvimage.h>
+#include <typeinfo>
+
+using std::string;
+using namespace flair::core;
+
+namespace flair { namespace filter {
+
+CvtColor::CvtColor(const core::IODevice* parent,std::string name,Conversion_t conversion) : IODevice(parent,name),output(0) {
+    this->conversion=conversion;
+
+    switch(conversion) {
+    case Conversion_t::GRAY:
+        try{
+            cvimage::Type const &imageType=dynamic_cast<cvimage::Type const &>(parent->GetOutputDataType());
+            output=new cvimage(this,imageType.GetWidth(),imageType.GetHeight(),cvimage::Type::Format::GRAY,"conversion",true,2);
+
+        } catch(std::bad_cast& bc) {
+            Err("io type mismatch\n");
+        }
+        break;
+    default:
+        Err("conversion not supported\n");
+    }
+}
+
+CvtColor::~CvtColor(void) {}
+
+cvimage* CvtColor::Output(void) {
+    return output;
+
+}
+
+DataType const &CvtColor::GetOutputDataType() const {
+    if(output!=NULL) {
+        return output->GetDataType();
+    } else {
+        return dummyType;
+    }
+}
+
+void CvtColor::UpdateFrom(const io_data *data) {
+    IplImage *img=((cvimage*)data)->img;
+
+    data->GetMutex();
+    output->GetMutex();
+
+    switch(conversion) {
+    case Conversion_t::GRAY:
+        switch(((cvimage*)data)->GetDataType().GetFormat()) {
+        case cvimage::Type::Format::YUYV:
+            //dspCvtColor(img,output->img,DSP_YUYV2GRAY);
+            break;
+        case cvimage::Type::Format::UYVY:
+            //dspCvtColor(img,output->img,DSP_UYVY2GRAY);
+            break;
+        case cvimage::Type::Format::BGR:
+            //dspCvtColor(img,output->img,DSP_BGR2GRAY);
+            break;
+        default:
+            Err("input format not supported\n");
+        }
+        break;
+    default:
+        Err("conversion not supported\n");
+    }
+
+    output->ReleaseMutex();
+    data->ReleaseMutex();
+
+    output->SetDataTime(data->DataTime());
+    ProcessUpdate(output);
+}
+
+} // end namespace filter
+} // end namespace flair
Index: /trunk/lib/FlairVisionFilter/src/CvtColor.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/CvtColor.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/CvtColor.h	(revision 122)
@@ -0,0 +1,89 @@
+/*!
+ * \file CvtColor.h
+ * \brief Image color conversion
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/07/17
+ * \version 4.0
+ */
+
+
+#ifndef CVTCOLOR_H
+#define CVTCOLOR_H
+
+#include <IODevice.h>
+
+namespace flair
+{
+    namespace core
+    {
+        class cvimage;
+    }
+}
+
+namespace flair
+{
+namespace filter
+{
+    /*! \class CvtColor
+    *
+    * \brief Image color conversion
+    *
+    * The conversion is done using the DSP of the DM3730.
+    */
+    class CvtColor : public core::IODevice
+    {
+        public:
+            /*!
+            \enum Conversion_t
+            \brief Conversion formats
+            */
+            enum class Conversion_t {
+                BGR,/*!< BGR 24 bits */
+                GRAY,/*!< gray 8 bits */
+                } ;
+
+            /*!
+            * \brief Constructor
+            *
+            * Construct an Ahrs.
+            *
+            * \param parent parent
+            * \param name name
+            * \param conversion conversion format
+            */
+            CvtColor(const core::IODevice* parent,std::string name,Conversion_t conversion);
+
+            /*!
+            * \brief Destructor
+            *
+            */
+            ~CvtColor();
+
+            /*!
+            * \brief Output image
+            *
+            * Output matrix is of the same size as declared in constructor. \n
+            * Its type depends of the conversion type.
+            *
+            * \return the output image
+            */
+            core::cvimage* Output(void);
+
+            core::DataType const &GetOutputDataType() const;
+
+        private:
+            /*!
+            * \brief Update using provided datas
+            *
+            * Reimplemented from IODevice.
+            *
+            * \param data data from the parent to process
+            */
+            void UpdateFrom(const core::io_data *data);
+
+            core::cvimage *output;
+            Conversion_t conversion;
+    };
+} // end namespace filter
+} // end namespace flair
+#endif // CVTCOLOR_H
Index: /trunk/lib/FlairVisionFilter/src/HoughLines.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/HoughLines.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/HoughLines.cpp	(revision 122)
@@ -0,0 +1,92 @@
+//  created:    2015/10/07
+//  filename:   HoughLines.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    HoughLines
+//
+//
+/*********************************************************************/
+
+#include "HoughLines.h"
+#include <cvimage.h>
+#include <cvmatrix.h>
+#include <Layout.h>
+#include <GroupBox.h>
+#include <SpinBox.h>
+#include <DoubleSpinBox.h>
+#include <typeinfo>
+
+#define MAX_LINES 100
+
+using std::string;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair { namespace filter {
+
+HoughLines::HoughLines(const IODevice* parent,const LayoutPosition* position,string name) : IODevice(parent,name) {
+    GroupBox* reglages_groupbox=new GroupBox(position,name);
+    fullRhoStep=new SpinBox(reglages_groupbox->NewRow(),"full rho step:","pixels",0,255,1,1);
+    fullThetaStep=new DoubleSpinBox(reglages_groupbox->LastRowLastCol(),"full theta step:","degrees",0,90,1,1);
+    trackingRhoStep=new SpinBox(reglages_groupbox->NewRow(),"tracking rho step:","pixels",0,255,1,1);
+    trackingThetaStep=new DoubleSpinBox(reglages_groupbox->LastRowLastCol(),"tracking theta step:","degrees",0,90,1,1);
+    trackingDeltaTheta=new DoubleSpinBox(reglages_groupbox->LastRowLastCol(),"tracking delta theta:","degrees",0,90,1,1);
+    nbPoints=new SpinBox(reglages_groupbox->NewRow(),"nb points:",0,10000,10,100);
+
+    isTracking=false;
+    lostLine=false;
+    initLine=false;
+    linesStorage = cvCreateMat(MAX_LINES, 1, CV_32FC2);
+
+    //init output matrix of same size as init
+    cvmatrix_descriptor* desc=new cvmatrix_descriptor(4,1);
+    desc->SetElementName(0,0,"distance");
+    desc->SetElementName(1,0,"orientation rad");
+    desc->SetElementName(2,0,"orientation deg");
+    desc->SetElementName(3,0,"line_detected");
+    output=new cvmatrix(this,desc,floatType,name);
+
+    try{
+        cvimage::Type const &imageType=dynamic_cast<cvimage::Type const &>(parent->GetOutputDataType());
+        if(imageType.GetFormat()!=cvimage::Type::Format::GRAY) {
+            Err("input image is not grey\n");
+        }
+    } catch(std::bad_cast& bc) {
+        Err("io type mismatch\n");
+    }
+}
+
+HoughLines::~HoughLines(void) {
+    cvReleaseMat(&linesStorage);
+}
+
+void HoughLines::UpdateFrom(const io_data *data) {
+ 
+}
+
+bool HoughLines::isLineDetected() const {
+    if(output->Value(3,0)==1) {
+        return true;
+    } else {
+        return false;
+    }
+}
+
+float HoughLines::GetOrientation(void) const {
+    return output->Value(1,0);
+}
+
+float HoughLines::GetDistance(void) const {
+    return output->Value(0,0);
+}
+
+cvmatrix *HoughLines::Output(void) const {
+    return output;
+}
+
+} // end namespace filter
+} // end namespace flair
Index: /trunk/lib/FlairVisionFilter/src/HoughLines.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/HoughLines.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/HoughLines.h	(revision 122)
@@ -0,0 +1,75 @@
+/*!
+ * \file HoughLines.h
+ * \brief HoughLines algorithm
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2015/10/07
+ * \version 4.0
+ */
+
+
+#ifndef HOUGHLINES_H
+#define HOUGHLINES_H
+
+#include <IODevice.h>
+#include <cv.h>
+
+namespace flair {
+    namespace core {
+        class cvimage;
+        class cvmatrix;
+    }
+    namespace gui {
+        class LayoutPosition;
+        class SpinBox;
+        class DoubleSpinBox;
+    }
+}
+
+namespace flair { namespace filter {
+    /*! \class HoughLines
+    *
+    * \brief HoughLines algorithm
+    *
+    * HoughLines is done using the DSP of the DM3730.
+    */
+    class HoughLines : public core::IODevice {
+        public:
+            /*!
+            * \brief Constructor
+            *
+            * Construct an OpticalFlow filter at given position. \n
+            * After calling this function, position will be deleted as it is no longer usefull. \n
+            *
+            * \param parent parent
+            * \param position position
+            * \param name name
+            */
+            HoughLines(const core::IODevice* parent,const gui::LayoutPosition* position,std::string name);
+
+            /*!
+            * \brief Destructor
+            *
+            */
+            ~HoughLines();
+
+            bool isLineDetected(void) const;
+            float GetOrientation(void) const;
+            float GetDistance(void) const;
+            core::cvmatrix *Output(void) const;
+
+        private:
+            void UpdateFrom(const core::io_data *data);
+            gui::SpinBox *fullRhoStep,*trackingRhoStep,*nbPoints;
+            gui::DoubleSpinBox *fullThetaStep,*trackingThetaStep,*trackingDeltaTheta;
+            bool isTracking,lostLine,initLine,noLine;
+            int nbLines;
+            float yawMean,prevYawMean;
+            float prevRhoMean,rhoMean;
+            float prevThetaMean,thetaMean;
+            float distance,orientation;
+            CvMat* linesStorage;
+            core::cvmatrix *output;
+    };
+} // end namespace filter
+} // end namespace flair
+#endif // HOUGHLINES_H
